%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018-2024  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function p = Pressure(Load, ksi, etta)

% Вычисление погонной нагрузки
switch Load.Span_Load.Law
    
    case {'TRAPEZOID', 'CHORD_PROPORTIONAL'}
        
        if (ksi < 0)
            
            switch Load.Extrapolation.Span_Load_0
                case 'CONSTANT'
                    Linear_Load = Load.Precomputed_Data.Linear_Load_Root;
                case 'LINEAR'
                    Linear_Load = Load.Precomputed_Data.Linear_Load_Root - Load.Precomputed_Data.Linear_Load_Difference * ksi;
                case 'ZERO_VALUE'
                    Linear_Load = 0;
            end
            
        else
            
            if (ksi > 1)
                
                switch Load.Extrapolation.Span_Load_1
                    case 'CONSTANT'
                        Linear_Load = Load.Precomputed_Data.Linear_Load_End;
                    case 'LINEAR'
                        Linear_Load = Load.Precomputed_Data.Linear_Load_Root - Load.Precomputed_Data.Linear_Load_Difference * ksi;
                    case 'ZERO_VALUE'
                        Linear_Load = 0;
                end

            else
                
                Linear_Load = Load.Precomputed_Data.Linear_Load_Root - Load.Precomputed_Data.Linear_Load_Difference * ksi;

            end
            
        end
        
    case 'LOAD_DIAGRAM'
        
        Linear_Load = Access_Array(Load.Span_Load.Load_Diagram_Data, ksi*Load.Precomputed_Data.Span_Length, ...
                                           Load.Extrapolation.Span_Load_0, Load.Extrapolation.Span_Load_1);
    
end

% Вычисление длины хорды
Chord_length = norm(Get_Cartesian_Coord(Load.Chord_Surface.A1_projected, ...
                                        Load.Chord_Surface.A2_projected, ...
                                        Load.Chord_Surface.A3_projected, ...
                                        Load.Chord_Surface.A4_projected, ksi, 0) - ...
                    Get_Cartesian_Coord(Load.Chord_Surface.A1_projected, ...
                                        Load.Chord_Surface.A2_projected, ...
                                        Load.Chord_Surface.A3_projected, ...
                                        Load.Chord_Surface.A4_projected, ksi, 1));

% Вычисление давления
switch Load.Chord_Pressure.Law
    
    case 'TRAPEZOID'
        
        if (etta < 0)
            
            switch Load.Extrapolation.Chord_Pressure_0
                
                case 'CONSTANT'
                    
                    if (~isempty(Load.Precomputed_Data.Chord_Pressure_Center))
                        p = Linear_Load / Chord_length * (1 + 6*(1/2 - Load.Precomputed_Data.Chord_Pressure_Center));
                    else
                        Chord_Pressure_Center = Access_Array(Load.Chord_Pressure.Trapezoid_Xd_Distr_Data, ksi, Load.Extrapolation.Trapezoid_Xd_0, Load.Extrapolation.Trapezoid_Xd_1);
                        p = Linear_Load / Chord_length * (1 + 6*(1/2 - Chord_Pressure_Center));
                    end
                    
                case 'LINEAR'
                    
                    if (~isempty(Load.Precomputed_Data.Chord_Pressure_Center))
                        p = Linear_Load / Chord_length * (1 - 6*(1/2 - Load.Precomputed_Data.Chord_Pressure_Center)*(2*etta - 1));
                    else
                        Chord_Pressure_Center = Access_Array(Load.Chord_Pressure.Trapezoid_Xd_Distr_Data, ksi, Load.Extrapolation.Trapezoid_Xd_0, Load.Extrapolation.Trapezoid_Xd_1);
                        p = Linear_Load / Chord_length * (1 - 6*(1/2 - Chord_Pressure_Center)*(2*etta - 1));
                    end
                    
                case 'ZERO_VALUE'
                    
                    p = 0;
                    
            end
            
        else
            
            if (etta > 1)
                
                switch Load.Extrapolation.Chord_Pressure_1

                    case 'CONSTANT'

                        if (~isempty(Load.Precomputed_Data.Chord_Pressure_Center))
                            p = Linear_Load / Chord_length * (1 - 6*(1/2 - Load.Precomputed_Data.Chord_Pressure_Center));
                        else
                            Chord_Pressure_Center = Access_Array(Load.Chord_Pressure.Trapezoid_Xd_Distr_Data, ksi, Load.Extrapolation.Trapezoid_Xd_0, Load.Extrapolation.Trapezoid_Xd_1);
                            p = Linear_Load / Chord_length * (1 - 6*(1/2 - Chord_Pressure_Center));
                        end

                    case 'LINEAR'

                        if (~isempty(Load.Precomputed_Data.Chord_Pressure_Center))
                            p = Linear_Load / Chord_length * (1 - 6*(1/2 - Load.Precomputed_Data.Chord_Pressure_Center)*(2*etta - 1));
                        else
                            Chord_Pressure_Center = Access_Array(Load.Chord_Pressure.Trapezoid_Xd_Distr_Data, ksi, Load.Extrapolation.Trapezoid_Xd_0, Load.Extrapolation.Trapezoid_Xd_1);
                            p = Linear_Load / Chord_length * (1 - 6*(1/2 - Chord_Pressure_Center)*(2*etta - 1));
                        end

                    case 'ZERO_VALUE'

                        p = 0;

                end

            else
                
                if (~isempty(Load.Precomputed_Data.Chord_Pressure_Center))
                    p = Linear_Load / Chord_length * (1 - 6*(1/2 - Load.Precomputed_Data.Chord_Pressure_Center)*(2*etta - 1));
                else
                    Chord_Pressure_Center = Access_Array(Load.Chord_Pressure.Trapezoid_Xd_Distr_Data, ksi, Load.Extrapolation.Trapezoid_Xd_0, Load.Extrapolation.Trapezoid_Xd_1);
                    p = Linear_Load / Chord_length * (1 - 6*(1/2 - Chord_Pressure_Center)*(2*etta - 1));
                end

            end
            
        end
        
    case 'USER_MODEL'
        
        Pressure_Distribution = Access_User_Model(ksi, Load);
        
        Pressure_Distribution(:,1) = Pressure_Distribution(:,1) * Chord_length;
        Pressure_Distribution(:,2) = Pressure_Distribution(:,2) * Linear_Load / trapz(Pressure_Distribution(:,1),Pressure_Distribution(:,2));
        
        p = Access_Array(Pressure_Distribution, etta*Chord_length, Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);
        
    otherwise
        
        Pressure_Distribution = Access_Model_X(ksi, Load);
        
        Pressure_Distribution(:,1) = Pressure_Distribution(:,1) * Chord_length;
        Pressure_Distribution(:,2) = Pressure_Distribution(:,2) * Linear_Load / trapz(Pressure_Distribution(:,1),Pressure_Distribution(:,2));
        
        p = Access_Array(Pressure_Distribution, etta*Chord_length, Load.Extrapolation.Chord_Pressure_0, Load.Extrapolation.Chord_Pressure_1);
        
end

p = p * Load.Correction_Coefficient;
